//+------------------------------------------------------------------+
//|                                                  EMA_CROSS_2.mq4 |
//|                                                      Coders Guru |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright ""
#property link      "www.forex-tsd.com"
#define MAGICMA  20060227

#include <stdlib.mqh>
#include <WinUser32.mqh>



/*
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
Changes:

A 0 (zero) SL Will result in no SL.  If you want to add SL Simply set it to desired amount.

Additions:

TotalEquitySL= This feature sets a total stoploss on entire account.  If account equity grows to a certain point and then drops
below the alowable draw down percentage AND there are no open trades then trading is suspended until human intervention.

TradTrail= Trailing Stop will kick in @ Trailing Stop and Trail by Trailing Step.


UseMailAlerts= Will email the details of the trade as it hits the history window regardless of whether or not EA closes or 
trade is closed by SL/TP

UseTimeFilter= If there are no pending trades AND Time is < Begin OR > End  then Trading is suspended

Reverse Trade Signal= reverses opening and closing criteria

You are now able to trade:
a)Multiple Pairs
b)Multiple TF on Same pair same platform
c)Multiple settings on (a) and/or (b) at the same time

System will automatically log trade settings and all trades associated with those settings. 
Logs can be found in the experts/files folder. File can be opened with Excel
for further analysis

TEST AWAY!       =) Nicholishen
*/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 //  extern bool sendtest=false;
   extern int ShortEma = 10; 
   extern int LongEma = 80;
   extern int IndicatorShift=0;
   extern bool immediate_trade = true; //Open trades immediately or wait for cross.
   extern bool reversal = true; //Use the originally reversal crossing method or not
   
   extern bool UseEmailAlerts=false;
   extern bool UseTotalEquitySL=false;
   extern double EquityRisk=50;
   extern double lots=0.1;              
   extern int TakeProfit=160;             
   extern int StopLoss=0;             
   extern bool UseTrail    = false; 
   extern bool ProfitTrailing = true;   
   extern int  TrailingStop   = 20;    
   extern int  TrailingStep   = 10;           
   extern bool UseTimeFilter=false;
   extern int BeginHour=8;
   extern int EndHour=18;
   extern string FileSavePrefix="EMAx";
   
   extern bool UseCloseOnReverseCriteria=false;
   static int TimeFrame;
   static int TestStart;
   int k;
   int mm,dd,yy,hh,min,ss,tf;
   string comment;
   string syym;
   string sttm;
int deinit()
  {

 int TestStop=CurTime();

 string filename=comment+"_"+yy+"_"+mm+"_"+dd+"_"+hh+"_"+min+"_"+syym+"_"+tf+".csv";
 
 
 int h1=FileOpen(filename,FILE_CSV|FILE_WRITE,',');
 FileWrite(h1,"ShortEma","LongEma","IndicatorShift","immediate_trade","reversal","UseEmailAlerts","UseTotalEquitySL","EquityRisk","lots","TakeProfit","StopLoss",
"UseTrail","ProfitTrailing","TrailingStop","TrailingStep","UseTimeFilter","BeginHour", "EndHour","UseCloseOnReverseCriteria",
"TestStart","TestStop","TotalProfit");
 
 
 FileWrite(h1,ShortEma,LongEma,IndicatorShift,immediate_trade,reversal,UseEmailAlerts,UseTotalEquitySL,EquityRisk,lots,TakeProfit,StopLoss,
UseTrail,ProfitTrailing,TrailingStop,TrailingStep,UseTimeFilter,BeginHour, EndHour,UseCloseOnReverseCriteria,
TimeToStr(TestStart,TIME_DATE|TIME_SECONDS),TimeToStr(TestStop,TIME_DATE|TIME_SECONDS),TotalProfit(TestStart,TestStop));

 FileWrite(h1,"");  
 FileWrite(h1,"TRADES");
 FileWrite(h1,"Order","OpenTime", "Type","Lots","Symbol","Price","SL","TP","Time","ClosePrice","Swap","Profit");
 /////////////
   double pr=0;
   for(int i=0;i<10000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderComment() ==comment ){
            
            if(OrderType()==OP_BUY){string typ="BUY";}else{typ="SELL";}
            FileWrite(h1,OrderTicket(),TimeToStr(OrderOpenTime(),TIME_DATE|TIME_SECONDS),typ,OrderLots(),OrderSymbol(),OrderOpenPrice(),OrderStopLoss(),
            OrderTakeProfit(),TimeToStr(OrderCloseTime(),TIME_DATE|TIME_SECONDS),OrderClosePrice(),OrderSwap(),OrderProfit() );
         }
         
      }else{
         break;
      }  
   }
//////////////
 
// GlobalVariableSet("STI",GlobalVariableGet("STI")+1);          
//---- 
  return;
  }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   TimeFrame=Period();
   if(!GlobalVariableCheck("EMAx")) GlobalVariableSet("EMAx",1);
   int ggg=GlobalVariableGet("EMAx");
   string gv=DoubleToStr(ggg,0);
   string sy=Symbol();
   
   
   comment=FileSavePrefix+"_"+gv;
   GlobalVariableSet("EMAx",ggg+1);
   
   mm=Month();dd=Day();yy=Year();min=Minute();hh=Hour();ss=Seconds();syym=Symbol();tf=Period();
   TestStart=CurTime();
   sttm=TimeToStr(TestStart,TIME_DATE|TIME_MINUTES);
   for(int i=0;i<1000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() ==comment ){
            k++;
         }
      }else{
         break;
      }  
   }
//Comment("\n","SYSTEM INITIALIZED ");   
//Comment(comment);


         


return(0);
}  
//+------------------------------------------------------------------+
// Converts Periods to String to track Mult Orders on Same Pair diff TF
//+------------------------------------------------------------------+

string Cmt(int x){
return(DoubleToStr(x,0));
}

double TotalProfit(int start,int end){
   double pr=0;
   for(int i=0;i<10000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() ==comment ){
            if(OrderOpenTime() >= TestStart)pr=pr+OrderProfit();
         }
      }else{
         break;
      }  
   }
   return(pr);
}
//+------------------------------------------------------------------+
// Time Filter
//+------------------------------------------------------------------+
int TimeFilter(){
   if(Hour()>EndHour || Hour()<BeginHour){
      return(1);
   }
   return(0);
}
//+------------------------------------------------------------------+
// Calculates Current Orders on TF,Pair,EA
//+------------------------------------------------------------------+

int CalculateCurrentOrders(){
   int orders=0;
   
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && comment ==OrderComment() ){
            orders++;
         }
      }
   }
   
   return(orders);
}
 //+------------------------------------------------------------------+
// Trading Signal
//+------------------------------------------------------------------+
int TradeSignal(){
   int w=IndicatorShift;
  double SEma = iMA(NULL,0,ShortEma,0,MODE_EMA,PRICE_CLOSE,w);
  double LEma = iMA(NULL,0,LongEma,0,MODE_EMA,PRICE_CLOSE,w);
   
   static int isCrossed  = 0;
   isCrossed = Crossed(LEma,SEma);
   
   if(reversal==false)
   {
      if(isCrossed==1) isCrossed=2;
      if(isCrossed==2) isCrossed=1;
   }
   
   //if(MM==true) Lots = LotSize(); //Adjust the lot size
  
   if(isCrossed == 1){
      return(1);
   }
   if(isCrossed == 2){
      return(2);
   }
   return(0);
}
   
int Crossed (double line1 , double line2)
   {
      static int last_direction = 0;
      static int current_direction = 0;
      
      if(TimeFrame!=Period())
      {
         TimeFrame=Period();
         return (0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down
      
      if(immediate_trade==false)
      {
         if(last_direction == 0) //first use
         {
               last_direction = current_direction;
               return(0);
         }
      }

      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }

//+------------------------------------------------------------------+
//| Open Conditions                       |
//+------------------------------------------------------------------+
void Sendit(){
double sl,tp; int res,error;
      res = OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl,tp,comment,MAGICMA,0,Blue); // def
      if(res<0){
         error=GetLastError();
         Print("Error = ",ErrorDescription(error));
      }
  
  }
void CheckForOpen(){
double sl,tp; int res,error;

  if(TradeSignal()==2){
      if (StopLoss==0) {sl=0;} else sl=Bid+Point*StopLoss;
      if (TakeProfit==0) {tp=0;} else tp=Bid-Point*TakeProfit;
     
      res = OrderSend(Symbol(),OP_SELL,lots,Bid,3,sl,tp,comment,MAGICMA,0,Blue); // def
      if(res<0){
         error=GetLastError();
         Print("Error = ",ErrorDescription(error));
      }
  }
  if(TradeSignal()==1){
      if (StopLoss==0) {sl=0;} else sl=Ask-Point*StopLoss;
      if (TakeProfit==0) {tp=0;} else tp=Ask+Point*TakeProfit;
   
      res = OrderSend(Symbol(),OP_BUY,lots,Ask,3,sl,tp,comment,MAGICMA,0,Red); // def
      if(res<0){
         error=GetLastError();
         Print("Error = ",ErrorDescription(error));
      }
  }
}   
  
//+------------------------------------------------------------------+
//| Close conditions                      |
//+------------------------------------------------------------------+
void CheckForClose(){

   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);    
      if (OrderType()==OP_BUY && OrderMagicNumber()==MAGICMA && Symbol()==OrderSymbol() && OrderComment() ==comment ){
         if (TradeSignal()==2) {                          // MA SELL signals
            int res = OrderClose(OrderTicket(),OrderLots(),Bid,3,White); // close 
            if(res<0){
               int error=GetLastError();
               Print("Error = ",ErrorDescription(error));
            }
         }     
      } 
      if (OrderType()==OP_SELL && OrderMagicNumber()==MAGICMA && Symbol()==OrderSymbol() && OrderComment() ==comment ){
         if (TradeSignal()==1) {                          // MA BUY signals
            res = OrderClose(OrderTicket(),OrderLots(),Ask,3,White); // close 
            if(res<0){
               error=GetLastError();
               Print("Error = ",ErrorDescription(error));
            }
         }     
      }  
   }    
}
   

//+------------------------------------------------------------------+
// Set Tight TP
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
// Traditional Trailing Stop
//+------------------------------------------------------------------+
void TrailingPositions() {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() == comment ) {
        if (OrderType()==OP_BUY) {
          if (!ProfitTrailing || (Bid-OrderOpenPrice())>TrailingStop*Point) {
            if (OrderStopLoss()<Bid-(TrailingStop+TrailingStep-1)*Point) {
              ModifyStopLoss(Bid-TrailingStop*Point);
            }
          }
        }
        if (OrderType()==OP_SELL) {
          if (!ProfitTrailing || OrderOpenPrice()-Ask>TrailingStop*Point) {
            if (OrderStopLoss()>Ask+(TrailingStop+TrailingStep-1)*Point || OrderStopLoss()==0) {
              ModifyStopLoss(Ask+TrailingStop*Point);
            }
          }
        }
      }
    }
  }
}

//+------------------------------------------------------------------+
// Order Modify function
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStop) {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=100*Point;

  fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, Pink);
  
}
//+------------------------------------------------------------------+
// Emails the Closed order as soon as it hits the history.
//+------------------------------------------------------------------+
void MailAlert(){
int f =0;
   for(int i=0;i<10000;i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderComment() == comment ){
            f++;
         }
      }else{
         break;
      }  
   }
   //Comment(" Trades in History ",f," Init cnt ",k  );
   if(k < f){
      string ordertyp;
      
      OrderSelect(f,SELECT_BY_POS,MODE_HISTORY);
      if(OrderType()==0)ordertyp="BUY";
      if(OrderType()==1)ordertyp="SELL";
     // SendMail("HI","HI");
      SendMail("CLOSED TRADE - STI - "+DoubleToStr(OrderProfit(),2),"  "+Symbol()+"    OpenTime: "+TimeToStr(OrderOpenTime())+"   Close Time: "+TimeToStr(OrderCloseTime())+"                     "+
      "Order Type "+ordertyp+"   Open "+DoubleToStr(OrderOpenPrice(),4)+"   Close "+DoubleToStr(OrderClosePrice(),4)+"  Profit ("+DoubleToStr(OrderProfit(),4)+")" );
      k++;
   }
 return;
} 
      
//+------------------------------------------------------------------+
// Safety net for trading.  Creates a total equity Stoploss
//+------------------------------------------------------------------+      
      
int EquitySL(){
static double eqhi;
   if(AccountEquity()>eqhi)eqhi=AccountEquity();
   if(AccountEquity() < eqhi * (( 100 - EquityRisk)/100))return(1);
return(0);
}

   
//+------------------------------------------------------------------+
// Expert Function
//+------------------------------------------------------------------+ 
int start(){
   Comment("\n",comment,"   Started @ ",sttm);
 //  if(sendtest)Sendit();

   if(Bars<100 || IsTradeAllowed()==false) return;

   if(CalculateCurrentOrders()==0) {
      if (UseTotalEquitySL && EquitySL()==1){
      Comment("Total Equity StopLoss Hit --------HUMAN INTERVENTION IS REQUIRED--------------");
      Alert("HUMAN INTERVENTION IS REQUIRED");
      return;
      }
      if(UseTimeFilter && TimeFilter()==1)return;
      CheckForOpen();
   }else{ 
      if(UseCloseOnReverseCriteria)CheckForClose();
   }
   
   if(UseTrail){TrailingPositions();}
   if(UseEmailAlerts){MailAlert();}
   
   return(0);
}



